digiKam Developer Documentation: Digikam::DXmlGuiWindow Class Reference

| digiKam Developer Documentation Professional Photo Management with the Power of Open Source

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Slots | Protected Member Functions | Protected Attributes | List of all members
Digikam::DXmlGuiWindow Class Referenceabstract

Generic class to use with all main window.

Inheritance diagram for Digikam::DXmlGuiWindow:

## Public Member Functions
| DXmlGuiWindow (QWidget *const parent=nullptr, Qt::WindowFlags f=Qt::WindowFlags())
QList< QAction * > | allActions () const
| Return all actions from internal collection.
void | cleanupActions ()
| Cleanup unwanted actions from action collection.
QString | configGroupName () const
void | createFullScreenAction (const QString &name)
| Create Full-screen action to action collection instance from managed window set through setManagedWindow().
void | createHelpActions (const QString &handbookSection, bool coreOptions=true)
| Create common actions from Help menu for all digiKam main windows.
void | createSettingsActions ()
| Create common actions to setup all digiKam main windows.
void | createSidebarActions ()
| Create common actions to handle side-bar through keyboard shortcuts.
bool | fullScreenIsActive () const
| Return true if managed window is currently in Full Screen Mode.
virtual DInfoInterface * | infoIface (DPluginAction *const ac)=0
| Return the interface instance to access to items information.
void | readFullScreenSettings (const KConfigGroup &group)
| Read full-screen settings from KDE config file.
virtual void | registerExtraPluginsActions (QString &)
void | registerPluginsActions ()
| Register all generic plugins action to this instance.
void | setConfigGroupName (const QString &name)
| Manage config group name used by window instance to get/set settings from config file.
void | setFullScreenOptions (int options)
| Set full-screen options to managed window.
void | unminimizeAndActivateWindow ()

## Static Public Member Functions
static QAction * | buildStdAction (StdActionType type, const QObject *const recvr, const char *const slot, QObject *const parent)
static QString | configFullScreenHideSideBarsEntry ()
static QString | configFullScreenHideStatusBarEntry ()
static QString | configFullScreenHideThumbBarEntry ()
static QString | configFullScreenHideToolBarsEntry ()
| Shared with FullScreenSettings.
static void | restoreWindowSize (QWindow *const win, const KConfigGroup &group)
static void | saveWindowSize (QWindow *const win, KConfigGroup &group)
static void | setGoodDefaultWindowSize (QWindow *const win)
static void | setupIconTheme ()
| If we have some local breeze icon resource, prefer it.

## Protected Slots
bool | slotClose ()

## Protected Member Functions
void | closeEvent (QCloseEvent *e) override
virtual void | customizedFullScreenMode (bool set)
| Reimplement this method if you want to manage customized view visibility in full-screen mode.
void | editKeyboardShortcuts (KActionCollection *const extraac=nullptr, const QString &actitle=QString())
| Call this method from your main window to show keyboard shortcut config dialog with an extra action collection to configure.
bool | eventFilter (QObject *obj, QEvent *ev) override
void | keyPressEvent (QKeyEvent *e) override
QAction * | showMenuBarAction () const
virtual void | showSideBars (bool visible)
| Reimplement this method if you want to manage sidebars visibility in full-screen mode.
QAction * | showStatusBarAction () const
virtual void | showThumbBar (bool visible)
| Reimplement this method if you want to manage thumbbar visibility in full-screen mode.
virtual bool | thumbbarVisibility () const
| Reimplement this method if managed window has a thumbbar.

## Protected Attributes
DLogoAction * | m_animLogo = nullptr

## Member Function Documentation

## ◆ createFullScreenAction()

void Digikam::DXmlGuiWindow::createFullScreenAction | ( | const QString & | name | ) |

This action is connected to slotToggleFullScreen() slot. 'name' is action name used in KDE UI rc file.

## ◆ customizedFullScreenMode()

void Digikam::DXmlGuiWindow::customizedFullScreenMode | ( | bool | set | ) |
| protectedvirtual

This method is called by switchWindowToFullScreen(). By default this method do nothing.

## ◆ editKeyboardShortcuts()

void Digikam::DXmlGuiWindow::editKeyboardShortcuts | ( | KActionCollection *const | extraac = `nullptr`,
|  | const QString & | actitle = `QString()`
| ) |  |
| protected

This method is called by slotEditKeys() which can be reimplemented in child class for customization.

## ◆ infoIface()

virtual DInfoInterface * Digikam::DXmlGuiWindow::infoIface | ( | DPluginAction *const | ac | ) |
| pure virtual

Implemented in Digikam::DigikamApp, ShowFoto::Showfoto, Digikam::ImageWindow, Digikam::LightTableWindow, Digikam::SurveyWindow, Digikam::ImportUI, and Digikam::QueueMgrWindow.

## ◆ registerPluginsActions()

void Digikam::DXmlGuiWindow::registerPluginsActions | ( |  | ) |

Call registerExtraPluginsActions() to plug other kind of plugins in GUI.

## ◆ showSideBars()

void Digikam::DXmlGuiWindow::showSideBars | ( | bool | visible | ) |
| protectedvirtual

By default this method do nothing.

## ◆ showThumbBar()

void Digikam::DXmlGuiWindow::showThumbBar | ( | bool | visible | ) |
| protectedvirtual

By default this method do nothing.

## ◆ thumbbarVisibility()

bool Digikam::DXmlGuiWindow::thumbbarVisibility | ( |  | ) | const
| protectedvirtual

This must return visibility state of it.